#!/usr/bin/env python

from string import join
from sys import exit,argv
from sss.ssslib import comm_lib, ConnectError
from xml.dom.minidom import parseString

comm=comm_lib(debug=('-d' in argv))
try:
    handle=comm.ClientInit('service-directory')
except ConnectError, msg:
    print "Error connecting to service directory: %s"%(msg)
    exit(1)
comm.SendMessage(handle,'''<get-location><location component='*' host='*' port='*' protocol='*' schema_version='*' tier='*'/></get-location>''')
response=comm.RecvMessage(handle)
comm.ClientClose(handle)
doc=parseString(response)
[root]=doc.getElementsByTagName("locations")
# first get data and figure out widths
output=[("Service","Protocol","Location","Version","Tier")]
for service in root.getElementsByTagName("location"):
    output.append((service.getAttribute('component'),service.getAttribute('protocol'),"%s:%s"%(service.getAttribute('host'),service.getAttribute('port')),service.getAttribute("schema_version"),service.getAttribute("tier")))

lendata=map(lambda x:map(len,x),output)
fsizes=tuple(map(lambda i:apply(max,map(lambda x:x[i],lendata)),range(len(lendata[0]))))
fstring="%%%ss   %%%ss   %%%ss   %%%ss   %%%ss"%fsizes
linelen=reduce(lambda x,y:x+y,map(int,fsizes))+12
output.sort()
for data in output:
    print fstring%data
    if data[0] == "Service":
        print linelen*"="
